
import ast
import sys

for i in range(10):
    ii = i

for i in range(10):
    if ii+1 == i:
        print(i)
        exit()

while i > 1000:
    exit()

def link(a, b):
    if a is None or b is None: return
    #print("        ",a,b,type(a), type(b))
    if type(a) == str: a = [a]
    if type(b) == str: b = [b]
    for n1 in a:
        for n2 in b:
            out.append('{} -> {};'.format(n2, n1))

def is_terminating(a):
    if type(a) == ast.Expr:
        e = a.value
        if type(e) == ast.Call:
            if type(e.func) == ast.Name and e.func.id == 'exit':
                return True
            if type(e.func) == ast.Attribute and e.func.value.id == 'sys' and e.func.attr == 'exit':
                return True
    return False

out = []
def process_body(b, prefix, linkto=None, with_end=False):
    prev = linkto
    for i,a in enumerate(b):
        name = prefix+'_'+str(i)
        nextprev = process_statement(a, name, prev)
        if nextprev is not None:
            prev = nextprev
    if with_end:
        end = prefix+"_stop"
        out.append('{}[label="", shape="box"]'.format(end))
        link(end, prev)
        prev = end
    return prev

def process_statement(a, prefix, linkto=None):
    t = type(a)
    if t == ast.If:
        begin = prefix+'_begin'
        end = prefix+'_end'
        out.append('{}[label="IF {}",tooltip="{}"]'.format(begin, a.lineno, escaped_source(a)))
        out.append('{}[label="",shape="point"]'.format(end))
        link(begin, linkto)
        link(end, process_body(a.body, prefix, begin))
        if len(a.orelse) == 0:
            link(end, begin)
        else:
            link(end, process_body(a.orelse, prefix+'_else', begin))
        return [end]
    elif t in [ast.For, ast.While]:
        tt = t.__name__.upper()
        prefix = prefix+'_for'
        begin = prefix+'_begin'
        end = prefix+'_end'
        out.append('{}[label="{} {}",tooltip="{}"]'.format(begin, tt, a.lineno, escaped_source(a)))
        out.append('{}[label="",shape="point"]'.format(end))
        link(begin, linkto)
        link(end, begin)
        end_of_body = process_body(a.body, prefix, begin)
        link(begin, end_of_body)
        if len(a.orelse) > 0:
            print("UNHANDLED orelse in loops")
        return [end]
    elif t == ast.FunctionDef:
        name = prefix+'_'+a.name
        out.append('{}[label="def {}",tooltip="{}"]'.format(name, a.name, escaped_source(a)))
        process_body(a.body, name, name, with_end=True)
        return None
    else:
        terminate = is_terminating(a)
        more = ',shape="box"' if terminate else ''
        out.append('{}[label="{}",tooltip="{}"{}]'.format(prefix, a.lineno, escaped_source(a), more))
        link(prefix, linkto)
        return [prefix]


prog_file = sys.argv[1] if len(sys.argv) > 1 else sys.argv[0]
lines = open(prog_file).readlines()

def escaped_source(a):
    l = lines[a.lineno-1][:-1]
    return l.replace('"', '\\"')
    
prog = ''.join(lines)
a = ast.parse(prog)
out.append('digraph "{}" {{'.format(prog_file))
out.append("   rankdir=LR;")
start = "START"
out.append('   {}[label="START",shape="box"]'.format(start))
process_body(a.body, 'r', start, with_end=True)
out.append("}")


res = '\n'.join(out)
print(res)

from graphviz import Source
import re
src = Source(res)
o = re.sub(r'.py$', '.gv', prog_file)
src.render(o, view=True)  
